//
//  Shader.fsh
//  EmitterDrawer
//
//  Created by mango on 7/22/13.
//  Copyright (c) 2013 mango. All rights reserved.
//
precision highp float;
varying vec2 texcoordOut;
varying vec4 colorVarying;
varying vec2 texcoordSrc;

uniform sampler2D texture;
uniform sampler2D srcTexture;
uniform sampler2D backbuffer;
uniform mediump float opacity;
float screen(float top,float bottom)
{
    return (1.0 - (1.0 - top) * (1.0 - bottom));
}
void main()
{
    vec4 textureColor = texture2D(texture, texcoordOut);
    vec4 backColor = texture2D(backbuffer, texcoordSrc);
    backColor.r = screen(backColor.r,textureColor.r);
    backColor.g = screen(backColor.g,textureColor.g);
    backColor.b = screen(backColor.b,textureColor.b);
    gl_FragColor = backColor;
}
