//
//  Shader.fsh
//  EmitterDrawer
//
//  Created by mango on 7/22/13.
//  Copyright (c) 2013 mango. All rights reserved.
//
precision highp float;

varying vec2 texcoordOut;
varying vec4 colorVarying;
varying vec2 texcoordSrc;

uniform sampler2D texture;
uniform sampler2D srcTexture;
uniform sampler2D backbuffer;
uniform mediump float opacity;

void main()
{
    vec4 t0 = texture2D(texture, texcoordOut);
    
    vec4 orig = texture2D(srcTexture, texcoordSrc*0.5+0.5);
    vec4 curr = texture2D(backbuffer, texcoordSrc*0.5+0.5);
    
    vec3 diff = curr.rgb - orig.rgb;
    float dm = dot(diff, diff);
    
    float alpha = clamp((opacity * colorVarying.a * t0.a * (3.0+0.05/sqrt(dm))), 0.0, 1.0);
    
    gl_FragColor = vec4(orig.rgb, alpha);
}
